SystemOrganization addCategory: #'GT-Tools'!
SystemOrganization addCategory: #'GT-Tools-Prototypes'!
SystemOrganization addCategory: #'GT-Tools-Utils'!
SystemOrganization addCategory: #'GT-Tools-Metaceller'!

GLMGlobalBrowserTemplate subclass: #GTClassicBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

GTClassicBrowser class
	instanceVariableNames: 'announcer'!

!GTClassicBrowser commentStamp: '<historical>' prior: 0!
self openOn: Smalltalk organization.!

GTClassicBrowser class
	instanceVariableNames: 'announcer'!

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/14/2010 01:08'!
browserActionsIn: b
	"just for test"
	b act: [ 
		(b pane port: #classCategoryToSelect) value: (Smalltalk organization categoriesMatching: 'RPackage*') first ] entitled: 'Find'.
! !

!GTClassicBrowser methodsFor: 'building' stamp: 'TudorGirba 5/20/2012 00:54'!
buildBrowser
	browser := GLMTabulator new.
	self browserActionsIn: browser.
	browser
		row: [:row | row column: #classCats; column: #classes; column: #categories; column: #methods ];
		row: #sourceCode.
	browser transmit to: #classCats; andShow: [ :a | self classCategoriesIn: a ].
	browser transmit to: #classes; from: #classCats; andShow: [ :a | self classesIn: a ].
	browser transmit to: #categories; from: #classes; andShow: [ :a | self categoriesIn: a ].
	browser transmit to: #methods; from: #classes; from: #categories; andShow: [ :a | self methodsIn: a ].
	browser transmit
		to: #sourceCode;
		from: #classes;
		from: #methods;
		from: #classCats;
		andShow: [ :a | self sourceCodeIn: a ].
	browser transmit
		fromOutsidePort: #classCategoryToSelect;
		to: #classCats port: #selection.
	browser transmit 
		fromOutsidePort: #classesToSelect;
		to: #classes.
	browser transmit 
		fromOutsidePort: #methodsToSelect;
		to: #methods.
	^ browser! !

!GTClassicBrowser methodsFor: 'building' stamp: 'TudorGirba 11/26/2010 17:44'!
categoriesIn: a
	^ (a list)
		allowsDeselection;
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		display: [ :class | class organization categories ]! !

!GTClassicBrowser methodsFor: 'building' stamp: 'DamienCassou 6/29/2011 08:55'!
classCategoriesIn: a
	^ a list
		display: [ :organization | organization categories];
		sorted;
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer! !

!GTClassicBrowser methodsFor: 'building' stamp: 'DamienCassou 6/29/2011 08:56'!
classesHierarchyIn: a
	a mondrian
		painting: [ :view :package | 
					view nodes: ((Smalltalk organization listAtCategoryNamed: package) collect: [ :name | Smalltalk classNamed: name ]).
					view edgesFrom: #superclass.
					view treeLayout ];
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		title: 'Hierarchy'! !

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/13/2010 16:32'!
classesIn: a
	self classesListIn: a.
	self classesHierarchyIn: a! !

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/13/2010 16:32'!
classesListIn: a
	(a tree)
		shouldValidate: true;
		display: [ :classCat | (Smalltalk organization listAtCategoryNamed: classCat) collect: [ :className | Smalltalk classNamed: className ] ];
		children: [ :each | each traitComposition traits ];
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		title: 'Class list'! !

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/13/2010 16:32'!
methodsIn: a
	(a list)
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		display: [ :class :category | (class organization listAtCategoryNamed: category) asSortedCollection ].
	^ (a list)
		useExplicitNotNil;
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		when: [ :class :category | class notNil and: [ category isNil ] ];
		display: [ :class :category | class selectors asSortedCollection ]! !

!GTClassicBrowser methodsFor: 'building' stamp: 'TudorGirba 9/21/2011 00:20'!
sourceCodeIn: a
	| lintBrowser |
	a smalltalkCode
		title: 'Method source';
		display: [ :class :method | class sourceCodeAt: method ];
		smalltalkClass: [ :class | class ].
	(a text)
		forSmalltalk;
		useExplicitNotNil;
		title: 'Class definition';
		display: [ :class | class definition ];
		when: [ :class | class notNil ].
	(a text)
		title: 'Class comment';
		display: [ :class | class comment ];
		useExplicitNotNil;
		when: [ :class | class notNil ].
	lintBrowser := GTLintBrowser new browser.
	lintBrowser
		allowNil;
		when: [ :clas :mth | clas notNil ].
	a custom: lintBrowser! !

GLMGlobalBrowserTemplate subclass: #GTCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTCodeBrowser commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GTCodeBrowser class methodsFor: 'accessing' stamp: 'tg 1/20/2010 10:50'!
defaultEnvironment
	^ GTSTModel defaultEnvironment! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 11/16/2009 15:11'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Glamorous ST Browser'.
	self layout.
	self onPackages.
	self onClassesFromPackages.
	self onInstVarsFromClasses.
	self onMethodsFromClasses.
	self onMethodsFromInstVars.
	self onDetailsFromPackagesFromClassesFromMethods.
	browser sendTo: #outer->#focusOnMethod from: #details->#focusOnMethod with: [:m | m ].
	browser sendTo: #packages->#selection from: #outer->#focusOnMethod with: [:method | method glmBehavior glmPackage].
	browser sendTo: #classes->#selection from: #outer->#focusOnMethod with: [:method | method glmBehavior ].
	browser sendTo: #methods->#selection from: #outer->#focusOnMethod with: [:method | method ]! !

!GTCodeBrowser methodsFor: 'opening' stamp: 'tg 1/20/2010 10:51'!
entity 
	^ GTSTPackage rootPackagesOn: self class defaultEnvironment! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 9/18/2009 09:36'!
layout
	browser
		column: #packages;
		column: [:c | c row: #classes; row: #instVars ];
		column: [:c | c row: #methods; row: #details] span: 3.! !

!GTCodeBrowser methodsFor: 'building' stamp: 'TudorGirba 2/24/2012 06:42'!
onClassesFromPackages
	browser
		transmit to: #classes; from: #packages;
		andShow: [ :a |
			a tree
					when: [:package | package isCollection not];
					display: [:package | package allClasses];
					children: [ :each | each traits ];
"					icon: [ :each | 
						each stBehavior theNonMetaClass browserIcon isNil ifFalse: 
							[ OBMorphicIcons iconNamed: each stBehavior theNonMetaClass browserIcon ]
						ifTrue: [ nil ] ];"
					format: [:class | class name];
					updateOn: SystemAnnouncement from: SystemAnnouncer announcer
		]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'TudorGirba 10/1/2011 21:24'!
onDetailsFromPackagesFromClassesFromMethods
	browser
		transmit to: #details; from: #classes; from: #methods; from: #packages; 
		andShow: [ :a | 
			 a smalltalkCode
					smalltalkClass: [:class | class stBehavior ];
					title: 'Method';
					display: [:class :method | method sourceCode ].
			a smalltalkCode
					title: 'Class';
					useExplicitNotNil;
					when: [:class :method | class notNil and: [method isNil]];
					display: [:class | class definition ].
			a text
					title: 'Comment';
					useExplicitNotNil;
					when: [:class :method | class notNil and: [method isNil]];
					display: [:class | class comment ].
			a list
					title: 'References';
					useExplicitNotNil;
					when: [:class | class notNil ];
					display: [:class | class references];
					format: [:each | each glmBehavior name, '>>', each name];
					populate: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ];
					updateOn: SystemAnnouncement from: SystemAnnouncer announcer.
			a list
					title: 'Senders';
					display: [:class :method | method senders];
					format: [:each | each glmBehavior name, '>>', each name];
					populate: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ];
					updateOn: SystemAnnouncement from: SystemAnnouncer announcer.
			a list
					title: 'Implementors';
					display: [:class :method | method implementors];
					format: [:each | each glmBehavior name, '>>', each name];
					populate: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ];
					updateOn: SystemAnnouncement from: SystemAnnouncer announcer.
		]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'TudorGirba 1/2/2012 01:38'!
onInstVarsFromClasses
	browser transmit to: #instVars; from: #classes; andShow: [ :a |  
		a list
				display: [ :class | class instVars ];
				tags: [ :each | 
					{ each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST'] } ];
				updateOn: SystemAnnouncement from: SystemAnnouncer announcer ]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'DamienCassou 4/13/2011 15:40'!
onMethodsFromClasses
	browser transmit to: #methods; from: #classes; andShow: [ :a | 
		a accordionArrangement.
		a list
				title: [:class | 'Instance (', class methods size printString, ')'];
				display: [ :class | class methods ];
				tags: [ :each | 
					{each glmCategory name} ].
		a list
				title: [:class | 'Meta (', class metaSide methods size printString, ')'];
				display: [ :class | class metaSide methods ];
				tags: [ :each | 
					{each glmCategory name} ].
		 ]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'TudorGirba 1/2/2012 01:39'!
onMethodsFromInstVars
	browser transmit to: #methods; from: #instVars; andShow: [ :a | 
		a list
				display: [ :var | var accessingMethods ];
				tags: [ :each | 
					{each glmCategory name.
					each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST']} ] ]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'TudorGirba 1/2/2012 01:39'!
onPackages
	browser
		transmit to: #packages;
		andShow: [ :a | 
			a tree
				children: [ :package | package subPackages ];
				format: [ :package | package name ];
				filterOn: [ :text :each | text match: each name ] ]! !

GLMGlobalBrowserTemplate subclass: #GTMetaceller
	instanceVariableNames: 'announcer cachedVersion cachedPackageMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Metaceller'!

!GTMetaceller commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:07'!
acceptCode: aText method: aMethod
	aMethod methodClass compile: aText asString classified: aMethod category.
	self announce: GTConfigChanged! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 10:25'!
acceptCode: aText version: aVersion 
	aVersion methodClass compile: aText asString classified: aVersion methodCategory.
	self announce: GTConfigChanged! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/12/2013 10:30'!
actionsForItem: anItem
	| retVal |
	retVal := OrderedCollection new.
 	retVal add: ((GLMGenericAction new) 
			action: [:list :version | self load: list selection fromVersion: version ];
			title: 'Load'
			yourself).
 	retVal add: ((GLMGenericAction new) 
			action: [:list | list selection inspect ];
			title: 'Inspect'
			yourself).
	(self isProject: anItem) ifTrue: [ retVal add: ((GLMGenericAction new) 
						action: [:list | self fetchProject: list selected ];
						title: 'Load configuration'
						yourself) ].
	^retVal! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 13:19'!
announce: anAnnouncement
	self announcer announce: anAnnouncement! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 13:18'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/10/2013 15:08'!
attributesForPackageSpec: aPackage
	| retVal |
	retVal := OrderedCollection new.
	(self isPackageLoaded: aPackage) ifTrue: [ 
		retVal add: TextEmphasis underlined.
		(self isPackageNewer: aPackage) ifTrue: [ retVal add: TextEmphasis bold ] ].
	^retVal! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/16/2013 11:23'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Metacello Browser'.
	browser
		act: [ :b | 
			Workspace new
				contents: self helpText;
				openLabel: 'Metaceller help' ]
		icon: GLMUIThemeExtraIcons glamorousHelp
		entitled: 'Help'.
	browser
		row: [  :r | r
				column: #configs;
				column: #versions;
				column: #packages span: 3 ];
		row: #details.
	browser transmit
		to: #configs;
		andShow: [ :a | self configurationsIn: a ].
	browser transmit
		from: #configs;
		to: #versions;
		andShow: [ :a | self versionBrowserOn: a ].
	browser transmit
		from: #versions;
		to: #details;
		andShow: [ :a | self detailsForVersion: a ].
	browser transmit
		from: #versions;
		to: #packages;
		andShow: [ :a | self packageBrowserOn: a ].
	browser transmit
		from: #packages;
		to: #details;
		andShow: [ :a | self detailsForPackage: a ].
	^ browser! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 16:35'!
childrenForConfig: aConfigClass
	[ ^(self projectsForVersion: aConfigClass project stableVersion) collect: [ :each | self configForProject: each ] thenSelect: [ :each | each notNil ] ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^#() ]! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2013 17:07'!
childrenForGroup: aGroupSpec version: aVersion
	^aVersion packagesForSpecNamed: aGroupSpec name! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2013 17:07'!
childrenForItem: aSpec version: aVersion
	(self isProject: aSpec) ifTrue: [  ^self childrenForProject: aSpec ].
	(self isGroup: aSpec) ifTrue: [ ^self childrenForGroup: aSpec version: aVersion ].
	^#()
! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/12/2013 16:45'!
childrenForProject: aProjectReference
	(self isProject: aProjectReference) ifFalse: [ ^#() ].
	(self isProjectLoaded: aProjectReference)
		ifTrue: [ ^aProjectReference version spec packages packageSpecsInLoadOrder ]
		ifFalse: [ ^#() ]! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 16:42'!
configForProject: aReferenceSpec 
	aReferenceSpec ifNil: [  ^nil ].
	aReferenceSpec projectReference ifNil: [  ^nil ].
	aReferenceSpec projectReference className ifNil: [  ^nil ].
	^Smalltalk at: (aReferenceSpec projectReference className asSymbol) ifAbsent: [ ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/16/2013 09:06'!
configurationsIn: a
	^ a tree
		title: 'Configurations';
		format: [ :configClass | 
					| text label version |
					label := self shortNameOf: configClass ];
		children: [ :configClass |
			 self childrenForConfig: configClass ];
		updateOn: GTConfigLoaded from: self announcer;
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousRefresh on: $r entitled: 'Refresh' with: [ :pane | self announce: GTConfigLoaded ];
		selectionAct: [ :list | list selection browse ] entitled: 'Browse implementation';
		selectionAct: [ :list | list selection project inspect ] entitled: 'Inspect'! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/10/2013 11:35'!
detailsForMethod: aBrowser
	aBrowser smalltalkCode
		smalltalkClass: [ :method | method methodClass ];
		display: [ :method | method asString ];
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Accept' with: [ :pane :method | self acceptCode: pane text method: method ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/10/2013 10:01'!
detailsForPackage: aBrowser
	aBrowser text
		display: [ :package | package asString ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/16/2013 11:42'!
detailsForVersion: aBrowser
	aBrowser smalltalkCode
		smalltalkClass: [ :version | version methodClass ];
		display: [ :version | version methodString ];
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Accept' with: [ :pane :version | self acceptCode: pane text version: version ]! !

!GTMetaceller methodsFor: 'opening' stamp: 'DiegoLont 4/9/2013 16:52'!
entity 
	^ (Object subclasses select: [:each | self isMetacelloConfig: each]) sort: [:a :b | a name < b name]! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
fetchProject: aProjectSpec
	" this seems more stable then the alternative:
			aProjectSpec resolveToLoadableSpec load.	
			that also fethces the versions we need.
	"
	aProjectSpec loadUsing: aProjectSpec loader gofer: nil.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
fetchVersion: aVersion
	aVersion fetch.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:30'!
groupsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [  ^#() ].
	^aVersion spec packages packageSpecsInLoadOrder select: [  :each | self isGroup: each ]! !

!GTMetaceller methodsFor: 'private' stamp: 'DiegoLont 4/8/2013 13:45'!
helpText
	^'Metaceller is a tool for browsing the Metacello configurations present in the image.

The Configurations tab lists all the projects from the ConfigurationOfXXX present in the image. Double clicking on an item spawns the configuration details.

The Versions tab lists all the versions defined in the configuration. The color coding shows:
- black = a possible baseline
- gray = not a possible baseline (probably due to packages no longer in the image)
- bold = the current version

The Imports tab shows how versions import from one another.

Upon selecting a version, the third pane shows the details of the specification of the version.

The Items tab shows the packages, groups and projects from the version. Each project can be expanded to display its items.

The color coding shows:
- blue = dirty packages 
- gray = packages that are not present in the image
- italics = groups

The "Newer in repository?" shows in red the packages that have newer versions published in the Monticello repository, thus indicating a possible need for update.'! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/10/2013 10:54'!
isGroup: aSpec 
	^aSpec isKindOf: MetacelloGroupSpec! !

!GTMetaceller methodsFor: 'opening' stamp: 'DiegoLont 4/10/2013 14:05'!
isMetacelloConfig: anObject
	(anObject respondsTo: #isMetacelloConfig) ifTrue: [  
		(anObject className beginsWith: 'Metacello') ifFalse: [ ^anObject isMetacelloConfig ] ].
	^false! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/10/2013 10:55'!
isPackage: aSpec 
	^(self isProject: aSpec) not and: [ (self isGroup: aSpec) not ]! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/10/2013 15:17'!
isPackageLoaded: aPackageSpec 
	^aPackageSpec isPackageLoaded! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 11:37'!
isPackageNewer: aPackageSpec 
	^false! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/12/2013 10:36'!
isPackageOlder: aPackageSpec 
	aPackageSpec isPackageLoaded ifFalse: [ ^false ].
	^aPackageSpec needsSaving! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/10/2013 10:53'!
isProject: aSpec 
	^aSpec isKindOf: MetacelloProjectReferenceSpec! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/10/2013 16:42'!
isProjectLoaded: aProjectSpec 
	(aProjectSpec isKindOf: MetacelloProjectReferenceSpec) ifFalse: [ ^aProjectSpec isPackageLoaded ]. 
	^(self configForProject: aProjectSpec) notNil! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:29'!
itemsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [  ^#() ].
	^(aVersion spec packages packageSpecsInLoadOrder) select: [  :each | (self isGroup: each) not ]! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
load: aSpec fromVersion: aVersion
	aVersion load: aSpec name.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
loadVersion: aVersion
	aVersion load.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/12/2013 10:42'!
nameForGroup: aGroup
	^Text string: aGroup label attribute: TextEmphasis italic! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/12/2013 10:38'!
nameForItem: anItem
	(self isProject: anItem) ifTrue: [  ^self nameForProject: anItem ].
	(self isGroup: anItem) ifTrue: [  ^self nameForGroup: anItem ].
	^self nameForPackageSpec: anItem! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/12/2013 10:53'!
nameForPackageSpec: aPackage
"	(self isPackageLoaded: aPackage) ifFalse: [ ^aPackage label  ].
	(self isPackageOlder: aPackage) ifTrue: [ ^
		Text string: aPackage label attributes: (Array with: TextEmphasis underlined with: TextEmphasis bold) ].
	^aPackage label
"
	^Text string: aPackage file attributes: (self attributesForPackageSpec: aPackage)! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/16/2013 11:46'!
nameForProject: aProjectReference
	| attributes |
	attributes := OrderedCollection new.
	(self isProjectLoaded: aProjectReference) ifTrue: [ attributes add: TextEmphasis underlined ].
	attributes add: TextColor blue.
	aProjectReference versionString 
		ifNil: [ ^(Text string: aProjectReference label attributes: attributes), (Text string: ' No version' attribute: TextColor red) ]
		ifNotNil: [ ^(Text string: aProjectReference label attributes: attributes), (Text string: (' ', aProjectReference versionString) attribute: TextColor blue) ].
	! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/16/2013 09:07'!
packageBrowserOn: aBrowser
	aBrowser tree
		title: 'Packages';
		display: [ :version | self itemsForVersion: version ];
		children: [ :item | self childrenForProject: item ];	"note: asking children of a group in a subproject is buggy, so we do not expand groups here."
		format: [ :item | self nameForItem: item ];
		tags: [ :packageSpec :version | self tagsOf: packageSpec in: version ];
		dynamicActionsOnSelection: [:list :version | self actionsForItem: list selection ];
		updateOn: GTConfigChanged from: self announcer.
	aBrowser tree
		title: 'Groups';
		children: [ :item :version | self childrenForItem: item version: version ];
		display: [ :version | self groupsForVersion: version ];
		updateOn: GTConfigChanged from: self announcer;
		format: [ :item | self nameForItem: item ].
	aBrowser roassal
		title: 'Dependencies';
		painting: [ :view :version | self viewDependenciesOf: version on: view ]! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/12/2013 16:43'!
packagesAndGroupsOf: aVersion
	(cachedVersion = aVersion) ifTrue: [  ^cachedPackageMap ].
	cachedPackageMap := Dictionary new.
	aVersion groups do: [:eachGroup |
		[ (aVersion packagesForSpecNamed: eachGroup name) do: [:eachPackage |
			cachedPackageMap at: eachPackage ifAbsentPut: [OrderedCollection new].
			(cachedPackageMap at: eachPackage) add: eachGroup name ] ]
		on: Exception do: [ "we eat exceptions for now" ] ].
	cachedVersion := aVersion.
	^ cachedPackageMap! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:29'!
packagesForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [  ^#() ].
	^aVersion spec packages packageSpecsInLoadOrder select: [  :each | self isPackage: each ]! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:29'!
projectsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [ ^#() ].
	^aVersion spec packages packageSpecsInLoadOrder select: [  :each | self isProject: each ]! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/8/2013 13:45'!
shortNameOf: config
	"self new shortNameOf: ConfigurationOfAlien"
	^ ((config name beginsWith: 'ConfigurationOf') 
		ifTrue: [config name copyFrom: 'ConfigurationOf' size + 1 to: config name size ] 
		ifFalse: [config name]) asString! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/12/2013 10:17'!
tagsOf: aPackageSpec in: aVersion
	^ (self packagesAndGroupsOf: aVersion) at: aPackageSpec ifAbsent: [OrderedCollection new]! !

!GTMetaceller methodsFor: 'private' stamp: 'DiegoLont 4/8/2013 13:45'!
validCurrentVersion: version

	version isNil ifTrue: [ ^false ].
	(version respondsTo: #versionStatus) 
		ifTrue: [ "Use #respondsTo: until 1.0-beta.23 is in general use"
			^#(allLoadedToSpec loadedToSpec loadedMatchConstraints) includes: version versionStatus ].
	^true! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/16/2013 11:33'!
versionBrowserOn: aBrowser
	aBrowser list
		title: 'Versions';
		display: [ :config | GTMetacellerVersion versionsForConfig: config ];
		updateOn: GTConfigChanged from: self announcer;
		selectionAct: [ :list | list selection inspect ] entitled: 'Inspect version';
		selectionAct: [ :list | self fetchVersion: list selection ] entitled: 'Fetch version';
		selectionAct: [ :list | self loadVersion: list selection ] entitled: 'Load version';
		format: [ :version | version textLabel ].
	aBrowser roassal
		title: 'Imports';
		painting: [:view :config | self viewVersionMapOf: config on: view].
	aBrowser list 
		title: 'Methods';
		display: [ :config | GTMetacellerVersion allMethodsForConfig: config ];
		updateOn: GTConfigChanged from: self announcer;
		selectionAct: [ :list | list selection method browse ] entitled: 'Browse method';
		format: [ :method | method selector ].! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/9/2013 14:11'!
versionSourceFor: aVersion
	^aVersion asString! !

!GTMetaceller methodsFor: 'roassal' stamp: 'DiegoLont 4/12/2013 16:47'!
viewDependenciesOf: version on: view
	"| view |
	view := MOViewRenderer new.
	self new viewDependenciesOf: (ConfigurationOfMoose project version: 'default') on: view.
	view open"
	| all | 
	all := Dictionary new.
	version packages do: [:each | all at: each name put: each].
	version projects do: [:each | all at: each name put: each].
	view shape label text: [:each | each name ].
	view nodes: all values.
	view edges: version packages from: [:eachPackage | all at: eachPackage name] toAll: [:eachPackage |
		eachPackage requires
			collect: [:each | all at: each ifAbsent: [ nil ] ] 
			thenSelect: [ :each | each notNil ] ].
	view horizontalDominanceTreeLayout layered! !

!GTMetaceller methodsFor: 'roassal' stamp: 'DiegoLont 4/11/2013 16:18'!
viewVersionMapOf: configClass on: view

	| nodes edges project |
	project := configClass project.
	nodes := Dictionary new.
	edges := OrderedCollection new.
	(Pragma allNamed: #version: in: configClass) do: [:prag | 
		nodes at: (prag argumentAt: 1) put: (project version: (prag argumentAt: 1)) ].
	(Pragma allNamed: #version:imports: in: configClass) do: [:prag | 
		| version imported |
		version := nodes at: (prag argumentAt: 1) put: (project version: (prag argumentAt: 1)).
		(prag argumentAt: 2) do: [:eachImportPrag |
			imported := nodes at: eachImportPrag ifAbsentPut: [ project version: eachImportPrag ].
			edges add: version -> imported ] ].
	view shape label text: [ :each | each versionNumber printString ].
	view nodes: nodes values.
	view edges: edges from: #key to: #value.
	view horizontalDominanceTreeLayout! !

GLMGlobalBrowserTemplate subclass: #GTProfStef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTProfStef commentStamp: 'tg 2/1/2010 15:40' prior: 0!
self openOn: SmalltalkSyntaxTutorial.!

!GTProfStef class methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:38'!
openOn: tutorial
	^ super openOn: (ProfStef goOn: tutorial viewedWith: GTProfStefNoView new)! !

!GTProfStef methodsFor: 'building' stamp: 'TudorGirba 2/26/2012 13:13'!
buildBrowser
	browser := GLMFinder new.
	browser title: 'Prof Stef'.
	browser show: [:a | 
		a smalltalkCode
		display: [ :lesson | lesson lesson ];
		when: [:lesson | lesson isKindOf: Lesson];
		title: [:lesson | lesson title];
		selectionPopulate: #selection
			on: $o
			entitled: 'Open (o)'
			with: [ :text :entity | 
				| result |
				result := [Compiler 
					evaluate: text selectedText
					for: entity
					logged: false] on: Error do: [nil].
				(result isNil or: [result isKindOf: GTProfStefNoView]) ifTrue: [nil] ifFalse: [result] ];
		selectionAct: 
				[ :text :entity | 
				(Compiler 
					evaluate: text selectedText
					for: entity
					logged: false) inspect ]
			on: $/
			entitled: 'Inspect (/)';
		populate: #selection icon: GLMUIThemeExtraIcons glamorousRight entitled: 'Next lesson'  with: [:text :lesson | ProfStef next ] ].
	^ browser! !

!GTProfStef methodsFor: 'opening' stamp: 'tg 2/1/2010 15:42'!
entity
	^ ProfStef goOn: SmalltalkSyntaxTutorial viewedWith: GTProfStefNoView new! !

GLMGlobalBrowserTemplate subclass: #GTProfStefEncyclopedia
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTProfStefEncyclopedia commentStamp: 'tg 2/2/2010 23:33' prior: 0!
self open!

!GTProfStefEncyclopedia methodsFor: 'building' stamp: 'TudorGirba 8/21/2011 09:30'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Prof Stef Encyclopedia'.
	browser column: #lessons; column: #details span: 4.
	browser transmit to: #lessons; andShow: [:a | 
		a list 
			title: 'Tutorials';
			send: [:class | ProfStef new lessonView: GTProfStefNoView new; goOn: class ]
			"morphicSelectionAct: [:each | each selection browse ] entitled: 'Browse'"].
	browser transmit from: #lessons; to: #details; andShow: [:a | 
		a custom: GTProfStef new browser noTitle ].
	^ browser! !

!GTProfStefEncyclopedia methodsFor: 'opening' stamp: 'TudorGirba 1/31/2011 01:34'!
entity
	^ AbstractTutorial allSubclasses ! !

GLMGlobalBrowserTemplate subclass: #GTRemoteMetaceller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTRemoteMetaceller commentStamp: 'tg 2/2/2010 23:07' prior: 0!
self open!

!GTRemoteMetaceller methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 01:48'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Remote Metaceller'.
	browser column: #configs; column: #details.
	browser transmit to: #configs; andShow: [ :a | 
		a list 
			title: 'Remote configurations';
			format: #name;
			act: [:list | list selection version load ] entitled: 'Load configuration code' ].
	browser transmit to: #details; from: #configs; andShow: [ :a | 
		a list 
			title: 'Details';
			format: #selector;
			display: [:reference | reference version snapshot definitions select: [:each | 
					each isMethodDefinition and: [each classIsMeta not] ]];
			act: [:list | list selection inspect ] entitled: 'Inspect'].
	^ browser ! !

!GTRemoteMetaceller methodsFor: 'opening' stamp: 'tg 2/2/2010 23:06'!
entity 
	^ self remoteConfigurations! !

!GTRemoteMetaceller methodsFor: 'private' stamp: 'tg 2/2/2010 23:06'!
remoteConfigurations
	| gofer packages |
	gofer := Gofer new
		disablePackageCache;
		squeaksource: 'MetacelloRepository';
		yourself.
	packages := Set new.
	gofer allResolved do: [ :each |
		| name |
		name := each packageName.
		((name beginsWith: 'ConfigurationOf') and: [ (packages includes: name) not ]) ifTrue: [
			packages add: name.
			gofer package: name ] ].
	^ gofer resolved! !

GLMBrowserTemplate subclass: #GTChaser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTChaser commentStamp: 'TudorGirba 1/31/2011 00:27' prior: 0!
The Chaser unifies the navigation of both senders and implementors. Each pane represents either a method reference or a symbol, and it reveals its implementors and the senders in two different tabs.

self openOn: #methodsBrowser!

!GTChaser methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 00:44'!
buildBrowser
	"self openOn: #browser"
	browser := GLMFinder new.
	browser title: [:each | 'Chasing Browser of #', each].
	browser show: [:a |
		a title: [ :each | self titleOf: each ].
		a custom: (self 
					methodsBrowserFor: #allSendersOf:
					title: 'Senders').
		a custom: (self 
					methodsBrowserFor: #allImplementorsOf:
					title: 'Implementors') ].
	^ browser! !

!GTChaser methodsFor: 'private' stamp: 'TudorGirba 1/30/2011 22:28'!
childrenOf: each
	^ (each isKindOf: MethodReference)
		ifTrue: [ each compiledMethod messages ]
		ifFalse: [ OrderedCollection new ] ! !

!GTChaser methodsFor: 'private' stamp: 'TudorGirba 10/18/2012 11:48'!
methodActionsFor: aListPresentation
	
	| actions |
	actions := OrderedCollection new.
	(aListPresentation selection isKindOf: MethodReference) ifTrue: [
		actions add: (GLMMorphicAction new 
						action: [:list | list selection browse]; 
						icon: GLMUIThemeExtraIcons glamorousBrowse;
						title: 'Browse';
						yourself) ].
	^ actions! !

!GTChaser methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 00:46'!
methodsBrowserFor: aSymbol title: aString
	"this defines a simple browser that can displayed both senders and implementors.
	aSymbol is either #allSendersOf: or #allImplementorsOf:"
	| methodsBrowser |
	methodsBrowser := GLMTabulator new.
	methodsBrowser row: #methods; row: #source.
	methodsBrowser title: aString.
	methodsBrowser transmit to: #methods; andShow: [ :a | 
		a tree
			showOnly: 20;
			display: "[ :each | aBlock value: each ]"
					[:each | self systemNavigation perform: aSymbol with: ((each isKindOf: MethodReference) ifTrue: [each selector ] ifFalse: [ each ])];
			format: [:method | self titleOf: method ];
			children: [:each | self childrenOf: each];
			dynamicActionsOnSelection: [ :list | self methodActionsFor: list ] ].
	methodsBrowser transmit from: #methods; to: #source; andShow: [:some |
		some text
			forSmalltalk: [:reference | reference actualClass ];
			display: [:reference | reference sourceCode ];
			whenKindOf: MethodReference ].
	methodsBrowser transmit from: #methods; toOutsidePort: #selection.
	^ methodsBrowser! !

!GTChaser methodsFor: 'private' stamp: 'TudorGirba 1/30/2011 22:22'!
titleOf: aSymbolOrReference
	^ (aSymbolOrReference isKindOf: MethodReference)
		ifTrue: [ aSymbolOrReference classSymbol , '>>' , aSymbolOrReference selector ]
		ifFalse: [ aSymbolOrReference ]! !

GLMBrowserTemplate subclass: #GTClassicChaser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTClassicChaser commentStamp: 'tg 1/15/2010 01:14' prior: 0!
self openOn: #browse!

!GTClassicChaser methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 19:07'!
buildBrowser
	"self openOn: #buildBrowser"

	| finder |
	finder := self finder.
	browser := GLMTabulator new.
	browser title: [ :each | 'Chasing ' , each asString ].
	browser
		row: #finder;
		row: #details.
	browser transmit 
		to: #finder;
		andShow: [:a | a custom: finder ].
	browser
		transmit to: #details;
		from: #finder;
		andShow: [:a | 
					(a text)
						forSmalltalk: [ :reference | reference actualClass ];
						display: [ :reference | [ reference compiledMethod getSource ] on: Error do: [ 'source not found' ] ];
						whenKindOf: MethodReference ].
	^ browser! !

!GTClassicChaser methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 15:13'!
finder
	| finder |
	finder := GLMFinder new.
	finder
		show: [ :a | 
			a title: [ :each | self titleOf: each ].
			self implementorsIn: a.
			self sendersIn: a ].
	^ finder! !

!GTClassicChaser methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 15:15'!
implementorsIn: a
	^ (a tree)
		title: 'Implementors';
		showOnly: 20;
		display: [ :each | 
					self systemNavigation
						allImplementorsOf:
							((each isKindOf: MethodReference)
								ifTrue: [ each selector ]
								ifFalse: [ each ]) ];
		format: [ :each | self titleOf: each ];
		selectionAct: [:each | each selection inspect ] on: $i entitled: 'Inspect';
		children: [ :each | 
					(each isKindOf: MethodReference)
						ifTrue: [ each compiledMethod messages ]
						ifFalse: [ OrderedCollection new ] ]! !

!GTClassicChaser methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 15:15'!
sendersIn: a
	^ (a tree)
		title: 'Senders';
		showOnly: 20;
		display: [ :each | 
					self systemNavigation
						allSendersOf:
							((each isKindOf: MethodReference)
								ifTrue: [ each selector ]
								ifFalse: [ each ]) ];
		format: [ :each | self titleOf: each ];
		selectionAct: [:each | each selection inspect ] on: $i entitled: 'Inspect';
		children: [ :each | 
					(each isKindOf: MethodReference)
						ifTrue: [ each compiledMethod messages ]
						ifFalse: [ OrderedCollection new ] ]! !

!GTClassicChaser methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 15:11'!
titleOf: aSymbolOrReference
	^ (aSymbolOrReference isKindOf: MethodReference)
		ifTrue: [ aSymbolOrReference classSymbol , '>>' , aSymbolOrReference selector ]
		ifFalse: [ aSymbolOrReference ]! !

GLMBrowserTemplate subclass: #GTCodeFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTCodeFinder methodsFor: 'building' stamp: 'TudorGirba 8/21/2011 23:58'!
buildBrowser 
	"self openOn: Smalltalk"
	browser := GLMFinder new.
	browser show: [:a | 
		a title: [ :object | object printString ].
		self smalltalkIn: a.
		].
	^ browser ! !

!GTCodeFinder methodsFor: 'building' stamp: 'TudorGirba 8/21/2011 23:57'!
smalltalkIn: composite 
	composite list 
		display: [ :smalltalk | {'Classes' -> Object withAllSubclasses} ];
		format: [ :each | each key, ' (', each value size asString ,')' ];
		send: #value;
		when: [:smalltalk | smalltalk == Smalltalk ]! !

GLMBrowserTemplate subclass: #GTDiffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTDiffer commentStamp: 'tg 12/29/2009 16:46' prior: 0!
self openOn: Collection withAllSubclasses andOn: MooseGroup withAllSubclasses!

!GTDiffer class methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 16:34'!
openOn: aCollectionOfClasses andOn: anotherCollectionOfClasses
	^ self new openOn: aCollectionOfClasses andOn: anotherCollectionOfClasses! !

!GTDiffer methodsFor: 'building' stamp: 'TudorGirba 1/30/2011 21:28'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Glamorous Diff Browser'.
	browser
		row: [:r | r column: #left; column: #right ];
		row: #diff.
	browser transmit toOutsidePort: #leftClasses; fromOutsidePort: #entity; transformed: [:assoc | assoc key].
	browser transmit toOutsidePort: #rightClasses; fromOutsidePort: #entity; transformed: [:assoc | assoc value].
	browser transmit to: #left; fromOutsidePort: #leftClasses; andShow: [:a | 
		(a custom: GTSimpleClassesMethodsBrowser new browser)
			title: 'Left' ].
	browser transmit to: #right; fromOutsidePort: #rightClasses; andShow: [:a | 
		(a custom: GTSimpleClassesMethodsBrowser new browser)
			title: 'Right' ].
	browser transmit to: #diff; 
		from: #left port: #selectedClass; from: #left port: #selectedMethod;
		from: #right port: #selectedClass; from: #right port: #selectedMethod;
		andShow: [:a | 
		a diff
			display: [:leftClass :leftMethod :rightClass :rightMethod | 
				Array with: (leftClass sourceCodeAt: leftMethod) with: (rightClass sourceCodeAt: rightMethod)
			]
		].
	^ browser! !

!GTDiffer methodsFor: 'opening' stamp: 'tg 12/29/2009 16:50'!
openOn: aCollectionOfClasses
	self browser openOn: aCollectionOfClasses andOn: aCollectionOfClasses! !

!GTDiffer methodsFor: 'opening' stamp: 'tg 12/29/2009 16:36'!
openOn: aCollectionOfClasses andOn: anotherCollectionOfClasses
	self browser openOn: aCollectionOfClasses -> anotherCollectionOfClasses! !

GLMBrowserTemplate subclass: #GTHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTHelper commentStamp: 'TudorGirba 10/8/2011 20:25' prior: 0!
self openOn: HelpOnHelp asHelpTopic!

!GTHelper methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 23:49'!
buildBrowser 
	"self openOn: HelpOnHelp"
	browser := GLMTabulator new.
	browser title: 'Helper'.
	browser act: [:b | b update ] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Refresh'.
	browser column: #index; column: #contents span: 2.
	browser transmit to: #index; andShow: [:a |
		a tree 
			title: 'Index';
			display: #asHelpTopic;
			children: #subtopics;
			rootsExpanded;
			icon: #icon;
			format: #title ].
	browser transmit from: #index; to: #contents; andShow: [:a | 
		a text 
			title: 'Contents';
			display: #contents ].
	^ browser ! !

GLMBrowserTemplate subclass: #GTLintBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTLintBrowser commentStamp: 'tg 12/29/2009 03:55' prior: 0!
self openOn: GLMPresentation withAllSubclasses asOrderedCollection!

!GTLintBrowser methodsFor: 'building' stamp: 'TudorGirba 1/2/2012 01:40'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Lint Browser'.
	browser column: #groups; column: #rules; column: #results.
	browser transmit from: #outer->#entity transformed: [:classOrCollection | classOrCollection isCollection ifFalse: [{ classOrCollection }] ifTrue: [ classOrCollection ]]; to: #groups; andShow: [ :a |
 		a list
			display: [:dic | RBCompositeLintRule lintChecks rules];
			allowNil;
			format: #name ].
	browser transmit to: #rules; from: #groups; andShow: [ :a | 
		a list
			display: [:group | group rules];
			format: #name ].
	browser transmit to: #results; from: #rules; from: #outer->#entity transformed: [:classOrCollection | classOrCollection isCollection ifFalse: [{ classOrCollection }] ifTrue: [ classOrCollection ]]; andShow: [ :a |
		a list
			display: [:rule :tuple | self getLintResult:
					(self runRule: rule forClasses: tuple) result] ].
			"tuple = {class. selector} from the browser. We select the class"
	browser transmit toOutsidePort: #faultyMethod; from: #results port: #selection.
	^ browser! !

!GTLintBrowser methodsFor: 'private' stamp: 'tg 1/16/2010 22:22'!
getLintResult: anEnvironment

	| results stream |
	results := OrderedCollection new.
	anEnvironment classesAndSelectorsDo: [:class :sel | results add: sel].
	^ results! !

!GTLintBrowser methodsFor: 'private' stamp: 'tg 1/16/2010 22:28'!
runRule: aRule forClasses: aClassesCollection

	| environment |
	environment := BrowserEnvironment new forClasses: aClassesCollection.
	^ SmalllintChecker runRule: aRule onEnvironment: environment! !

GLMBrowserTemplate subclass: #GTMessageTallyBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTMessageTallyBrowser commentStamp: 'TudorGirba 8/21/2011 09:34' prior: 0!
This browser shows the result of applying method tally to a given computation block.

Example:
self openOn: [10000 timesRepeat: [1.23 printString]]!

!GTMessageTallyBrowser methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 01:00'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Message Tally'.
	browser
		column: #messages;
		column: #details.
	(browser transmit)
		to: #messages;
		andShow: [ :a | self messagesIn: a ].
	(browser transmit)
		to: #details;
		from: #messages;
		andShow: [ :a | self sourceCodeIn: a ].
	^ browser! !

!GTMessageTallyBrowser methodsFor: 'building' stamp: 'TudorGirba 8/21/2011 09:35'!
messagesIn: a
	^ (a tree)
		title: 'Message tree';
		children: [ :each | each sonsOver: -1 ];
		morphicSelectionAct: [ :list | GTUtils browseMethod: list selection method ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse (b)';
		format: [ :each | Text fromString: (GTUtils printCompiledMethod: each method) , ' (' , each tally printString , ')']! !

!GTMessageTallyBrowser methodsFor: 'building' stamp: 'TudorGirba 12/1/2011 11:36'!
openOn: aBlock
	^ super openOn: (MessageTally new spyEvery: 1 on: aBlock; yourself) inspect! !

!GTMessageTallyBrowser methodsFor: 'building' stamp: 'TudorGirba 12/1/2011 11:34'!
sourceCodeIn: a
	^ a smalltalkCode
		title: [ :each | GTUtils printCompiledMethod: each method ];
		morphicAct: [ :text :each | GTUtils browseMethod: each method ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			entitled: 'Browse';
		smalltalkClass: [ :each | each method methodClass ];
		display: [ :each | each method methodClass sourceCodeAt: each method selector ifAbsent: [ 'unknown' ] ]! !

GLMBrowserTemplate subclass: #GTMessageTallyFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTMessageTallyFinder commentStamp: 'tg 12/29/2009 04:07' prior: 0!
self openOn: [10000 timesRepeat: [1.23 printString]]!

!GTMessageTallyFinder methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/2/2012 01:41'!
buildBrowser
	| finder |
	finder := GLMFinder new.
	finder show: [:a | 
		a list
			title: 'Messages';
			display: [:each | each sonsOver: -1];
			format: [:each | each printString, ' (', each tally printString, ')']].
	browser := GLMTabulator new.
	browser row: #messages; row: #source.
	browser transmit to: #messages; andShow: [:a | a custom: finder].
	browser transmit to: #source; from: #messages; andShow: [ :a | 
		a text
			title: 'Source';
			forSmalltalk: [:each | each method methodClass];			
			display: [:each | each method methodClass sourceCodeAt: each method selector ifAbsent: ['unknown']]
	].
	browser 
		act: [:x |
			(StringHolder new contents: (String streamContents: [:s | x entity report: s; close])) openLabel: 'Spy Results' wrap: false.]
		entitled: 'Print report'.	
	^ browser! !

!GTMessageTallyFinder methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:07'!
openOn: aBlock
	^ super openOn: (MessageTally new spyEvery: 1 on: aBlock; yourself)! !

GLMBrowserTemplate subclass: #GTMetacellerDetails
	instanceVariableNames: 'master'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTMetacellerDetails commentStamp: 'tg 2/1/2010 22:36' prior: 0!
self openOn: ConfigurationOfGlamour!

!GTMetacellerDetails methodsFor: 'building' stamp: 'TudorGirba 5/20/2012 00:52'!
buildBrowser
	| innerBrowser |
	browser := GLMAccumulator new.
	browser title: 'Glamorous Metaceller'.

	innerBrowser := GLMTabulator new.
	innerBrowser column: #versions; column: #packages span: 2.
	innerBrowser transmit to: #versions; andShow: [ :a |
		self versionsIn: a ].
	innerBrowser transmit to: #packages; from: #versions; andShow: [ :a | 
		self packagesIn: a ].

	browser show: [ :a |
		a title: 	[:config | self shortNameOf: config ].
		a custom: innerBrowser ].
	browser transmit toOutsidePort: #entity; fromOutsidePort: #strongSelection.
! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'DaleHenrichs 2/8/2010 14:16'!
goferForVersion: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	version packages do: [:each | 
		(each isKindOf: MetacelloPackageSpec) ifTrue: [ g package: each name]].
	^ g! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'TudorGirba 10/16/2011 12:52'!
labelOfItemSpec: packageSpec

	| label text |
	label := packageSpec name.
	(packageSpec isKindOf: MetacelloPackageSpec) ifTrue: [label := packageSpec file].
	(packageSpec isKindOf: MetacelloProjectReferenceSpec) ifTrue: [label := packageSpec name, ' ', packageSpec versionString].
	
	text := ((packageSpec isKindOf: MetacelloPackageSpec) and: [
		self packageSpecNeedsSaving: packageSpec])
			ifTrue: [Text string: label attribute: TextColor blue] 
			ifFalse: [ 
				Text fromString: label
				"Text 
					string: label
					attribute: ((self master useCacheDuring: [ packageSpec isLoaded ]) 
					ifTrue: [TextColor black] 
					ifFalse: [TextColor gray])"].
	(packageSpec isKindOf: MetacelloGroupSpec) ifTrue: [ 
		text addAttribute: TextEmphasis italic from: 1 to: text size ].
	^ text! !

!GTMetacellerDetails methodsFor: 'accessing' stamp: 'DaleHenrichs 2/8/2010 14:26'!
master
	^ master! !

!GTMetacellerDetails methodsFor: 'accessing' stamp: 'DaleHenrichs 2/8/2010 14:26'!
master: anObject
	master := anObject! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
packageSpec: packageSpec hasNewerVersionsFrom: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	g package: packageSpec name.
	^ g resolved first name ~= packageSpec currentVersionInfo name! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
packageSpecNeedsSaving: aPackageSpec
	| copy |
	copy := aPackageSpec workingCopy.
	copy isNil ifTrue: [^ false ].
	^ copy needsSaving! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
packagesAndGroupsOf: version
	| packageMap |
	packageMap := Dictionary new.
	version groups do: [:eachGroup |
		(version packagesForSpecNamed: eachGroup name) do: [:eachPackage |
			packageMap at: eachPackage ifAbsentPut: [OrderedCollection new].
			(packageMap at: eachPackage) add: eachGroup name ] ].
	^ packageMap! !

!GTMetacellerDetails methodsFor: 'building' stamp: 'TudorGirba 12/30/2011 22:36'!
packagesIn: a
	a title: [ :version | version name ].
	(a tree)
		title: 'Items';
		display: [ :version | version spec packages packageSpecsInLoadOrder ];
		format: [ :packageSpec | self labelOfItemSpec: packageSpec ];
		children: [ :spec | 
					(spec isKindOf: MetacelloProjectReferenceSpec)
						ifTrue: [ spec projectReference version spec packages packageSpecsInLoadOrder ]
						ifFalse: [ #() ] ];
		tags: [ :packageSpec :version | self tagsOf: packageSpec in: version ];
		act: [ :list | list selection inspect ] entitled: 'Inspect';
		act: [ :list :version | version load: list selection name ] entitled: 'Load'.
	(a mondrian)
		title: 'Dependencies';
		painting: [ :view :version | self viewDependenciesOf: version on: view ].
	(a smalltalkCode)
		title: 'Script';
		variableBindings: {#spec -> MetacelloProjectReferenceSpec new};
		display: [ :version | version spec printString ].
"	(a list)
		title: 'Newer in repository?';
		display: [ :version | version spec packages packageSpecsInLoadOrder ];
		format: [ :packageSpec :version | 
					((packageSpec isKindOf: MetacelloPackageSpec) and: [ self packageSpec: packageSpec hasNewerVersionsFrom: version ])
						ifTrue: [ Text string: packageSpec name attribute: TextColor red ]
						ifFalse: [ packageSpec name ] ];
		act: [ :list | list selection inspect ] entitled: 'Inspect'."
"	(innerBrowser transmit)
		toOutside: #strongSelection;
		from: #packages port: #strongSelection;
		when: [ :selection | selection isKindOf: MetacelloProjectReferenceSpec ];
		transformed: [ :selection | selection projectReference projectClass ]"! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:35'!
shortNameOf: config
	"self new shortNameOf: ConfigurationOfAlien"
	^ ((config name beginsWith: 'ConfigurationOf') 
		ifTrue: [config name copyFrom: 'ConfigurationOf' size + 1 to: config name size ] 
		ifFalse: [config name]) asString! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:28'!
spawnNewVersionFrom: sourceVersion in: aSmalltalkClass
	| vn targetVersionString selector |
	vn := sourceVersion versionString asMetacelloVersionNumber copy incrementMinorVersionNumber.
	targetVersionString := OBTextRequest prompt: 'Enter the target version number (source: ', sourceVersion versionString, ').' template: vn printString.
	selector := OBTextRequest prompt: 'Enter the new method selector' template: ('version', (targetVersionString copyWithout: $.) copyWithout: $-), ':'.
	selector numArgs ~~ 1 ifTrue: [ ^ self error: 'Selector must take a single argument: ', selector ].
	MetacelloVersionConstructor 
		spawnPackageMethodIn: aSmalltalkClass new 
		named: selector asSymbol
		sourceVersion: sourceVersion versionString
		targetVersion: targetVersionString ! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
tagsOf: packageSpec in: version
	^ (self packagesAndGroupsOf: version) at: packageSpec ifAbsent: [OrderedCollection new]! !

!GTMetacellerDetails methodsFor: 'building' stamp: 'TudorGirba 12/30/2011 23:05'!
versionsIn: composer
	composer list
		title: 'Versions';
		display: [:config | config project versions reverse ];
		format: [:each :config | each versionNumber asString ];
		selectionAct: [:list :config | 
			self spawnNewVersionFrom: list selection in: config.
			list update.
			] entitled: 'Spawn new version';
		selectionAct: [:list | 
			(self goferForVersion: list selection) browseRemoteChanges ] entitled: 'Browse remote changes';
		selectionAct: [:list  | list selection inspect] entitled: 'Inspect'.
	composer mondrian
		title: 'Imports';
		painting: [:view :config | self viewVersionMapOf: config on: view]! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'TudorGirba 10/16/2011 19:19'!
viewDependenciesOf: version on: view
	"| view |
	view := MOViewRenderer new.
	self new viewDependenciesOf: (ConfigurationOfMoose project version: 'default') on: view.
	view open"
	| all | 
	all := Dictionary new.
	version packages do: [:each | all at: each name put: each].
	version projects do: [:each | all at: each name put: each].
	view shape label text: [:each | each name ].
	view nodes: all values.
	view edges: version packages from: [:eachPackage | all at: eachPackage name] toAll: [:eachPackage |
		eachPackage requires collect: [:each | all at: each ]].
	view horizontalDominanceTreeLayout layered! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
viewVersionMapOf: configClass on: view

	| prag1 prag2 nodes edges version imported |
	prag1 := Pragma allNamed: #version:imports: in: configClass.
	prag2 := Pragma allNamed: #version: in: configClass.
	nodes := Dictionary new.
	edges := OrderedCollection new.
	prag2 do: [:prag | 
		nodes at: (prag argumentAt: 1) put: (configClass project version: (prag argumentAt: 1)) ].
	prag1 do: [:prag | 
		version := nodes at: (prag argumentAt: 1) put: (configClass project version: (prag argumentAt: 1)).
		(prag argumentAt: 2) do: [:eachImportPrag |
			imported := nodes at: eachImportPrag ifAbsentPut: [configClass project version: eachImportPrag].
			edges add: version -> imported.
			]
		].
	view shape label text: [:each | each versionNumber printString].
	view nodes: nodes values.
	view edges: edges from: #key to: #value.
	view horizontalDominanceTreeLayout! !

GLMBrowserTemplate subclass: #GTSensitiveMethodBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTSensitiveMethodBrowser commentStamp: '<historical>' prior: 0!
self openOn: (GLMEditor>>#createResultBrowserWithBindings:andScript:)!

!GTSensitiveMethodBrowser methodsFor: 'building' stamp: 'TudorGirba 4/22/2012 20:53'!
buildBrowser 
	browser := GLMTabulator new.
	
	browser column: #source; column: #preview.
	browser transmit to: #source; andShow: [:a |
		a smalltalkCode
			title: 'Source';
			smalltalkClass: [ :anObject | anObject methodClass ];
			display: [:anObject | anObject getSource ]].
	browser transmit to: #preview; from: #source port: #selectionInterval; fromOutsidePort: #entity; andShow:[:a | 
		a text
			display: [:interval :method |
				self mostSpecificInterestingNodeIn: method atPosition: interval];
			selectionAct: [:each | each displayValue inspect] on: $i;
			selectionAct: [:each | each displayValue explore] on: $I entitled: 'Explore' 
			].
	^ browser! !

!GTSensitiveMethodBrowser methodsFor: 'private' stamp: 'TudorGirba 4/22/2012 21:29'!
mostSpecificInterestingNodeIn: aMethod atPosition: anInterval

	| parseTree nodesIncludingInterval |
	parseTree := aMethod parseTree annotateInClass: GLMEditor.
	nodesIncludingInterval := parseTree allChildren select: [ :each | 
		each start <= anInterval first and: [
			each stop >= anInterval first ]].
	^ nodesIncludingInterval reverse 
		detect: [ :each | 
			each isMessage  ] 
		ifNone: [ nil ]! !

GLMBrowserTemplate subclass: #GTSimpleClassesMethodsBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Utils'!

!GTSimpleClassesMethodsBrowser commentStamp: 'TudorGirba 1/30/2011 21:27' prior: 0!
This is a simple browser showing a list of classes and their methods. It is meant to be used inside other browsers.

self openOn: Collection withAllSubclasses!

!GTSimpleClassesMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 1/2/2012 01:42'!
buildBrowser
	browser := GLMTabulator new.
	browser column: #classes; column: #methods.
	browser transmit to: #classes; andShow: [ :a |
		a list
			display: [:classes | classes ];
			sorted: [:x :y | x name < y name]].
	browser transmit to: #methods; from: #classes; andShow: [ :a |
		a list
			display: [:class | class selectors];
			sorted].
	browser transmit toOutsidePort: #selectedClass; from: #classes.
	browser transmit toOutsidePort: #selectedMethod; from: #methods.
	^ browser! !

Announcement subclass: #GTConfigChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Metaceller'!

GTConfigChanged subclass: #GTConfigLoaded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Metaceller'!

Object subclass: #GTMetacellerVersion
	instanceVariableNames: 'method version configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Metaceller'!

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 4/16/2013 11:26'!
allMethodsForConfig: aConfiguration
	^aConfiguration methods collect: [ :each |
		self on: aConfiguration method: each ]! !

!GTMetacellerVersion class methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 11:27'!
isValidVersion: aVersion
	aVersion pragmas do: [ :each |
		(each key beginsWith: 'version') ifTrue: [  ^true ] ].
	^false! !

!GTMetacellerVersion class methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 11:07'!
load: aString 
	self version ifNotNil: [ self version load: aString ]! !

!GTMetacellerVersion class methodsFor: 'instance creation' stamp: 'DiegoLont 4/16/2013 09:13'!
on: aConfiguration method: aMethod
	^self basicNew
		initialize: aConfiguration method: aMethod;
		yourself! !

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 4/16/2013 16:29'!
versionsForConfig: aConfiguration
	^(aConfiguration methods
		select: [ :each | self isValidVersion: each ]
		thenCollect: [ :each | self on: aConfiguration method: each ]) 
			asSortedCollection: [ :a :b | a name > b name ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
configuration
	^ configuration! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
configuration: anObject
	configuration := anObject! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:39'!
determineVersion
	self method pragmas do: [ :each |
		(each key beginsWith: 'version') ifTrue: [ ^self configuration project version: (each arguments first) ] ].
	^nil! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 16:38'!
fetch
	self version ifNotNil: [ self version fetch ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:34'!
groups
	self version ifNotNil: [ ^self version groups ].
	^#()! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 11:17'!
initialize: aConfiguration method: aMethod
	self initialize.
	method := aMethod.
	configuration := aConfiguration! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 16:26'!
load
	self version ifNotNil: [ self version load ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
method
	^ method! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
method: anObject
	method := anObject! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:43'!
methodCategory
	^self method category! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:42'!
methodClass
	^self configuration! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:42'!
methodString
	^self method asString! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 09:15'!
name
	method pragmas do: [  :each |
		(each key beginsWith: 'version') ifTrue: [ ^each arguments first ] ].
	^method selector! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:48'!
packages
	self version ifNil: [ ^#() ].
	^self version packages! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:47'!
packagesForSpecNamed: aVersionString 
	self version ifNotNil: [ ^self version packagesForSpecNamed: aVersionString ].
	^#()! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:48'!
projects
	self version ifNil: [ ^#() ].
	^self version projects! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:38'!
selector
	^self method selector! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:34'!
spec
	self version ifNotNil: [ ^self version spec ].
	^nil! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:32'!
textLabel
	self version ifNil: [ ^Text string: self name attribute: TextColor red ].
	^self name! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:18'!
version
	^ version ifNil: [ version := self determineVersion ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
version: anObject
	version := anObject! !

Object subclass: #GTProfStefNoView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTProfStefNoView commentStamp: 'TudorGirba 1/31/2011 01:37' prior: 0!
This is a utility class to circumvent the design of ProfStef.!

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:02'!
close! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:02'!
open
! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:05'!
showLesson: aLesson
	^ aLesson lesson! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:02'!
showLesson: aLesson withTitle: aString
	^ aLesson! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/7/2010 19:05'!
showTutorialNode: aTutorialNode
	^ aTutorialNode ! !

Object subclass: #GTTraitBrowser
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTTraitBrowser commentStamp: 'DamienCassou 7/20/2011 07:27' prior: 0!
self open.!

!GTTraitBrowser class methodsFor: 'initialize-release' stamp: 'DamienCassou 7/24/2011 09:43'!
open
	^ self new
		open;
		yourself! !

!GTTraitBrowser methodsFor: 'building-presentations' stamp: 'DamienCassou 7/26/2011 20:20'!
allMethodsIn: constructor
	constructor dynamic presentation: [:a :classOrTrait|
		a accordionArrangement.
		(classOrTrait isKindOf: Class)
			ifTrue: [	a tree
						title: 'hierarchy methods';
						display: [classOrTrait allSuperclasses];
						children: [:superclass | (superclass isKindOf: Class) ifTrue: [superclass selectors sorted]]].
		a list
			title: 'trait methods';
			display: [classOrTrait selectors difference: classOrTrait localSelectors];
			sorted
		]! !

!GTTraitBrowser methodsFor: 'building-browsers' stamp: 'DamienCassou 7/26/2011 20:26'!
build1Browser
	| tabulator |
	tabulator := (GLMTabulator new)
		row: #finder;
		row: #traitComposition size: 20;
		row: #source;
		yourself.
	tabulator title: [ :classOrTrait | classOrTrait name ].
	(tabulator transmit)
		to: #finder;
		andShow: [ :a | a custom: self build2Finder ].
	(tabulator transmit)
		from: #finder;
		to: #traitComposition;
		andShow: [ :a | self classOrTraitNameIn: a ].
	(tabulator transmit)
		from: #finder;
		to: #source;
		andShow: [ :a | a text ].
	(tabulator transmit)
		"passive because otherwise we would display the currently selected method for the newly selected class which is likely to not exist"
		passivelyFrom: #finder port: #selection;
		from: #finder port: #method;
		to: #source;
		andShow: [ :a | self methodSourceIn: a ].
	^ tabulator! !

!GTTraitBrowser methodsFor: 'building-browsers' stamp: 'DamienCassou 7/26/2011 19:46'!
build2Finder
	| finder |
	finder := GLMFinder new.
	finder fixedSizePanes: 2.
	finder show: [ :a | a title: [:classOrTrait | classOrTrait name]; custom: self build3Stacker].
	
	"Simulates a selection on the default entity displayed on the finder"
	finder transmit fromOutsidePort: #entity; toOutsidePort: #selection.
	^ finder! !

!GTTraitBrowser methodsFor: 'building-browsers' stamp: 'DamienCassou 7/26/2011 19:50'!
build3Stacker
	| stacker |
	stacker := GLMStacker new.
	stacker panes: #(methods hierarchy traits).
	(stacker transmit)
		to: #methods;
		andShow: [ :a | a title: 'methods'.
				a custom: self build4Methods].
	(stacker transmit)
		to: #hierarchy;
		andShow: [ :a | 	a title: 'hierarchy'. self hierarchyIn: a ].
	(stacker transmit)
		to: #traits;
		andShow: [ :a | a title: 'traits'. self traitsIn: a ].
	(stacker transmit)
		from: #hierarchy;
		toOutsidePort: #selection.
	(stacker transmit)
		from: #traits;
		toOutsidePort: #selection.
	(stacker transmit)
		from: #methods;
		toOutsidePort: #method.
	^ stacker! !

!GTTraitBrowser methodsFor: 'building-browsers' stamp: 'DamienCassou 7/25/2011 09:53'!
build3StackerBis
	| dynamic |
	dynamic := GLMTabulator new row: #stacker; yourself.
	dynamic transmit to: #stacker; andShow: [:a | 
		a dynamic
			display: [:classOrTrait | |stacker|
				self halt.
				stacker := GLMStacker new.
				stacker aPane: #methods.
				(classOrTrait isKindOf: Class)
					ifTrue: [stacker aPane: #hierarchy.
							(stacker transmit)
								to: #hierarchy;
								andShow: [ :c | self hierarchyIn: c].
							(stacker transmit)
								from: #hierarchy;
								toOutsidePort: #selection].
				(classOrTrait traitComposition notEmpty)
					ifTrue: [stacker aPane: #traits.
							(stacker transmit)
								to: #traits;
								andShow: [ :c | self traitsIn: c].
							stacker transmit
								from: #traits;
								toOutsidePort: #selection].
				(stacker transmit)
					to: #methods;
					andShow: [ :c | 
						c title: 'methods'.
						self localMethodsIn: c.
						self allMethodsIn: c].
				(stacker transmit)
					from: #methods port: #localSelectors;
					toOutsidePort: #method.
				stacker]].
	^ dynamic! !

!GTTraitBrowser methodsFor: 'building-browsers' stamp: 'DamienCassou 7/26/2011 20:21'!
build4Methods
	|stacker|
	stacker := GLMStacker new.
	stacker panes: #(local all).
	stacker transmit to: #local; andShow: [:a | a title: 'local'. self localMethodsIn: a].
	stacker transmit to: #all; andShow: [:a | a title: 'external'. self allMethodsIn: a].
	stacker transmit from: #local; toOutsidePort: #selection.
	^ stacker! !

!GTTraitBrowser methodsFor: 'building-presentations' stamp: 'DamienCassou 7/20/2011 08:37'!
classOrTraitNameIn: constructor
	^ constructor label
		display: [:classOrTraitName | classOrTraitName name, ': ', classOrTraitName traitComposition printString]
	
	
	! !

!GTTraitBrowser methodsFor: 'building-presentations' stamp: 'DamienCassou 7/26/2011 19:46'!
hierarchyIn: constructor
	^ constructor list
		whenKindOf: Class;
		display: [:class | class allSuperclasses]! !

!GTTraitBrowser methodsFor: 'building-presentations' stamp: 'DamienCassou 7/26/2011 19:48'!
localMethodsIn: constructor
	^ constructor list
		display: [:class | class localSelectors];
		send: #yourself as: #localSelectors;
		sorted
	! !

!GTTraitBrowser methodsFor: 'building-presentations' stamp: 'DamienCassou 7/21/2011 11:10'!
methodSourceIn: constructor
	^ (constructor text)
		forSmalltalk: [:class | class];
		display: [ :classOrTrait :selector | [classOrTrait sourceCodeAt: selector]
											on: Error
											do: ['Error: ', classOrTrait name, '>>', selector] ]! !

!GTTraitBrowser methodsFor: 'initialize-release' stamp: 'DamienCassou 7/24/2011 09:43'!
open
	browser := self build1Browser.
	browser openOn: NSCollectionStream 
	! !

!GTTraitBrowser methodsFor: 'building-presentations' stamp: 'DamienCassou 7/26/2011 19:47'!
traitsIn: constructor
	^ constructor list
		display: #traits! !

Object subclass: #GTUtils
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Utils'!

!GTUtils class methodsFor: 'utils' stamp: 'TudorGirba 5/16/2012 21:12'!
browseMethod: aCompiledMethod
	Smalltalk tools browser 
		fullOnClass: aCompiledMethod methodClass 
		selector: aCompiledMethod selector! !

!GTUtils class methodsFor: 'utils' stamp: 'TudorGirba 1/31/2011 01:09'!
printCompiledMethod: method
	^ String streamContents: [:stream | stream print: method methodClass; nextPutAll: '>>'; nextPutAll: method selector storeString]! !

Object subclass: #GTVisualizations
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Utils'!

!GTVisualizations methodsFor: 'as yet unclassified' stamp: 'tg 5/8/2010 18:17'!
viewPragmaConstellation
	"self new viewPragmaConstellation"
	| view |
	view := MOViewRenderer new.
	self viewPragmaConstellationOn: view.
	view openWithStatusbar! !

!GTVisualizations methodsFor: 'as yet unclassified' stamp: 'TudorGirba 2/26/2011 21:44'!
viewPragmaConstellationOf: pragmas on: view
	
	| pragmaTypes |
	pragmaTypes := pragmas groupedBy: #keyword.
	view shape ellipse fillColor: Color lightGray; withoutBorder.
	view nodes: (pragmas collect: [:each | each method methodClass]).
	view shape rectangle 
		text: #name;
		fillColor: Color gray;
		fontColor: Color white;
		linearFontSize: [:each | 
			(pragmaTypes at: each) size ] within: pragmaTypes keys;
		withoutBorder.
	view nodes: pragmaTypes keys.
	view shape line color: Color veryVeryLightGray; width: 3.
	view edges: pragmas from: [:each | each method methodClass] to: #keyword.
	view layout: MOGraphVizLayout new.
! !

!GTVisualizations methodsFor: 'as yet unclassified' stamp: 'tg 5/8/2010 18:17'!
viewPragmaConstellationOn: view
	
	| pragmas |
	pragmas := OrderedCollection new.
	Object withAllSubclassesDo: [:each |
		Pragma withPragmasIn: each do: [:p |
			pragmas add: p]].
	self viewPragmaConstellationOf: pragmas on: view! !
